<?php

/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Models;

use App\Http\Base\BaseModel;
use App\Http\Providers\iam\core\model\OracleOCIConnector;
use Carbon\Carbon;
use Services\Helper\FileSyncHelper;
use Illuminate\Database\Capsule\Manager;
use Illuminate\Support\Facades\DB;

class ItemModel extends BaseModel
{
    /**
     * table name from database
     */
    protected $table = "item";

    /**
     *   alias table for relation issues
     */
    protected $aliasTable = "item";

    /**
     * primary key from table remember eloquent doesnt support composite primary key
     */
    protected $primaryKey = "row_id";
    /**
     * check the incrementing boolean if the incrementing from database is false then the value is false by default
     */
    public $incrementing = false;
    /**
     * fillable property for eloquent attribute cast
     */
    protected $fillable = [
        "row_id", "id", "namaItem", "deskripsi", "category", "UOM", "image", "date_updated", "expense_account", "destination_type_code",
        "item_price", "kapalId", "expense_account_id", "part_number", "instalasi", "jenis_instalasi", "type_id", "enabled_flex",
        "item_groups", "item_subgroups", "item_subsubgroups", "meal_class", "meal_type", "stockable"
    ];
    /**
     * Creating raw object from table that, this purpose for making you easier for remembering all attribute
     */

    /**
     * paging for default paging purpose
     * if you want to add new paging property you have to add the property in this array
     * you have to add the relation value
     * remember this is not suported casting value you have to handle by your self
     */
    protected $aliasPaging = [
        "id" => "item.id",
        "namaItem" => "item.namaItem",
        "deskripsi" => "item.deskripsi",
        "category" => "item.category",
        "part_number" => "item.part_number",
        "UOM" => "item.UOM",
        "namaKapal" => "kapalId.namaKapal",
    ];

    /**
     * relation from ' . itempemakaianstok . ' by ' . itemId
     * join itempemakaianstok on itempemakaianstok.id = item.itemId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationItempemakaianstokItemId($alias = "itempemakaianstok")
    {
        $this->getQuery()->join("itempemakaianstok as $alias", "$alias.itemId", "=", "item.id");
        return $this;
    }

    /**
     * relation from ' . itempenerimaanbarang . ' by ' . itemId
     * join itempenerimaanbarang on itempenerimaanbarang.id = item.itemId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationItempenerimaanbarangItemId($alias = "itempenerimaanbarang")
    {
        $this->getQuery()->join("itempenerimaanbarang as $alias", "$alias.itemId", "=", "item.id");
        return $this;
    }

    /**
     * relation from ' . itempenyesuaianstok . ' by ' . itemId
     * join itempenyesuaianstok on itempenyesuaianstok.id = item.itemId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationItempenyesuaianstokItemId($alias = "itempenyesuaianstok")
    {
        $this->getQuery()->join("itempenyesuaianstok as $alias", "$alias.itemId", "=", "item.id");
        return $this;
    }

    /**
     * relation from ' . itempermintaanbarang . ' by ' . itemId
     * join itempermintaanbarang on itempermintaanbarang.id = item.itemId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationItempermintaanbarangItemId($alias = "itempermintaanbarang")
    {
        $this->getQuery()->join("itempermintaanbarang as $alias", "$alias.itemId", "=", "item.id");
        return $this;
    }

    /**
     * relation from ' . itempindahstokkapal . ' by ' . itemId
     * join itempindahstokkapal on itempindahstokkapal.id = item.itemId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationItempindahstokItemId($alias = "itempindahstokkapal")
    {
        $this->getQuery()->join("itempindahstokkapal as $alias", "$alias.itemId", "=", "item.id");
        return $this;
    }

    /**
     * relation from ' . stokkapal . ' by ' . itemId
     * join stokkapal on stokkapal.id = item.itemId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationStokkapalItemId($alias = "stokkapal")
    {
        $this->getQuery()->join("stokkapal as $alias", "$alias.itemId", "=", "item.id");
        return $this;
    }

    public function joinRelationKapalId($alias = "kapalId")
    {
        $this->getQuery()->join("kapal as $alias", "$alias.id", "=", "item.kapalId");
        return $this;
    }


    public function syncErrorFromOracleHO($itemID, $kapalID, $fromCMS = false)
    {
        (new LogsyncoracleModel)->setLogSync("Sync Recovery Master Item", Carbon::now()->toDateTimeString(), "", "start");
        echo "start sync recovery item from oracle", PHP_EOL;
        $oracleOCI = new OracleOCIConnector();
        $oracleOCI->getConnection()->select(self::getSyncErrorOracleQuery($itemID, $kapalID))->execute();
        $rows = $oracleOCI->fetchAll();
        $return = false;
        if ($rows) {
            $item = new self();
            $return = $item->storingDataFromOracle($rows, $fromCMS);
        }
        (new LogsyncoracleModel)->setLogSync("Sync Recovery Master Item", Carbon::now()->toDateTimeString(), "", "success");
        $oracleOCI->closeConnection();
        return $return;
    }

    public function syncFromOracleHO($syncTable, $fromCMS = false)
    {
        (new LogsyncoracleModel)->setLogSync("Master Item / Barang", Carbon::now()->toDateTimeString(), "", "start");
        echo "start sync item data from oracle", PHP_EOL;
        $oracleOCI = new OracleOCIConnector();
        $oracleOCI->getConnection()->select(self::getOracleQuery($syncTable, 0, 0))->execute();
        $lastUpdate = $syncTable->last_sync;
        while (($rows = $oracleOCI->fetchAll()) !== false) {
            $item = new self();
            $item->storingDataFromOracle($rows, $fromCMS);
            if (!empty($rows->LAST_UPDATE_DATE)) $lastUpdate = $rows->LAST_UPDATE_DATE;
            $syncTable = \App\Http\Models\SyncUtilities\StagingSyncTableModel::find($syncTable->id);
            $syncTable->last_sync = $lastUpdate;
            $syncTable->update();
        }
        (new LogsyncoracleModel)->setLogSync("Master Item / Barang", Carbon::now()->toDateTimeString(), "", "success");
        $oracleOCI->closeConnection();
    }


    public static function getSyncErrorOracleQuery($itemID, $kapalID)
    {
        $query = "SELECT ITEMV.DESCRIPTION, ITEMV.INVENTORY_ITEM_ID, ITEMV.SEGMENT1, ITEMV.ITEM_TYPE, ITEMV.PRIMARY_UOM_CODE, ITEMV.AKUN,
                  ITEMV.LAST_UPDATE_DATE, ITEMV.ITEM_PRICE, ITEMV.URL, ITEMV.TYPE_ID, ITEMV.ORGANIZATION_ID, ITEMV.EXPENSE_ACCOUNT_ID,
                  ITEMV.DESTINATION_TYPE_CODE, ITEMV.PART_NUMBER, ITEMV.INSTALASI, ITEMV.JENIS_INSTALASI, ITEMV.ENABLED_FLAG, ITEMV.ITEM_GROUPS,
                  ITEMV.ITEM_SUBGROUPS, ITEMV.ITEM_SUBSUBGROUPS, ITEMV.MEAL_CLASS, ITEMV.MEAL_TYPE, ITEMV.STOCK_ENABLED_FLAG,
                  ROWNUM rn
                FROM pelni_scm_items_v ITEMV
                WHERE ITEMV.INVENTORY_ITEM_ID = '" . $itemID . "' AND ITEMV.ORGANIZATION_ID = '" . $kapalID . "'";
        return $query;
    }

    public static function getOracleQuery($staging, $startRow, $endRow)
    {
        $query = "SELECT 
                  ITEMV.DESCRIPTION,
                  ITEMV.INVENTORY_ITEM_ID,
                  ITEMV.SEGMENT1,
                  ITEMV.ITEM_TYPE,
                  ITEMV.PRIMARY_UOM_CODE,
                  ITEMV.AKUN,
                  TO_CHAR( ITEMV.LAST_UPDATE_DATE, 'YYYY/MM/DD HH24:MI:SS') AS LAST_UPDATE_DATE,
                  ITEMV.ITEM_PRICE,
                  ITEMV.URL,
                  ITEMV.TYPE_ID,
                  ITEMV.ORGANIZATION_ID,
                  ITEMV.EXPENSE_ACCOUNT_ID,
                  ITEMV.DESTINATION_TYPE_CODE,
                  ITEMV.PART_NUMBER,
                  ITEMV.INSTALASI,
                  ITEMV.JENIS_INSTALASI,
                  ITEMV.ENABLED_FLAG,
                  ITEMV.ITEM_GROUPS,
                  ITEMV.ITEM_SUBGROUPS,
                  ITEMV.ITEM_SUBSUBGROUPS,
                  ITEMV.MEAL_CLASS,
                  ITEMV.MEAL_TYPE,
                  ITEMV.STOCK_ENABLED_FLAG,
                  ROWNUM rn
                FROM pelni_scm_items_v ITEMV
                WHERE
                 ITEMV.LAST_UPDATE_DATE >=
                  TO_TIMESTAMP('" . $staging->last_sync . "', 'yyyy-mm-dd HH24:MI:SS')
                ORDER BY ITEMV.LAST_UPDATE_DATE ASC";
        return $query;
    }


    public function mapperOracle($oracle)
    {
        $this->id = $oracle->INVENTORY_ITEM_ID;
        $this->namaItem = $oracle->SEGMENT1;
        $this->deskripsi = utf8_encode($oracle->DESCRIPTION);
        $this->category = $oracle->ITEM_TYPE;
        $this->UOM = $oracle->PRIMARY_UOM_CODE;
        $this->date_updated = $oracle->LAST_UPDATE_DATE;
        $this->expense_account = $oracle->AKUN;
        $this->destination_type_code = $oracle->DESTINATION_TYPE_CODE;
        $this->item_price = $oracle->ITEM_PRICE;
        $this->kapalId = $oracle->ORGANIZATION_ID;
        $this->expense_account_id = $oracle->EXPENSE_ACCOUNT_ID;
        $this->part_number = utf8_encode($oracle->PART_NUMBER);
        $this->instalasi = $oracle->INSTALASI;
        $this->jenis_instalasi = $oracle->JENIS_INSTALASI;
        $this->enabled_flex = $oracle->ENABLED_FLAG;
        $this->item_groups = $oracle->ITEM_GROUPS;
        $this->item_subgroups = $oracle->ITEM_SUBGROUPS;
        $this->item_subsubgroups = $oracle->ITEM_SUBSUBGROUPS;
        $this->meal_class = $oracle->MEAL_CLASS;
        $this->meal_type = $oracle->MEAL_TYPE;
        $this->type_id = intval($oracle->TYPE_ID);
        $this->stockable = $oracle->STOCK_ENABLED_FLAG;

        if (!empty($oracle->URL)) {
            $fileSyncHandler = new FileSyncHelper();
            $fileSyncHandler->setUrl($oracle->URL . "/download");
            $fileSyncHandler->productFile()->setNameFile(md5($oracle->URL) . ".jpg");
            $fileSyncHandler->store();
            if ($fileSyncHandler->hasFile())
                $this->image = $fileSyncHandler->getFile();
        }
    }

    public function storingDataFromOracle($oracle, $fromCMS = false)
    {
        if (intval($oracle->ITEM_PRICE) > 1) { } else {
            $oracle->ITEM_PRICE = 1;
        }
        $itemExist = (new self())->getQuery()
            ->where("item.namaItem", "=", $oracle->SEGMENT1)
            ->where("item.kapalId", "=", $oracle->ORGANIZATION_ID)
            ->where("item.id", "=", $oracle->INVENTORY_ITEM_ID)
            ->first();
        if ($itemExist) {
            if ($fromCMS) {
                DB::beginTransaction();
            } else {
                Manager::beginTransaction();
            }
            $model = self::find($itemExist->row_id);
            try {
                $model->mapperOracle($oracle);
                $model->update();
                if ($fromCMS) {
                    DB::commit();
                } else {
                    Manager::commit();
                }
                echo $model->namaItem . " " . $this->getTable() . "updated ", PHP_EOL;
                (new LogsyncoracleModel)->setLogSync("Master Item / Barang : " . $oracle->INVENTORY_ITEM_ID . " - " . $oracle->SEGMENT1, Carbon::now()->toDateTimeString(), "", "updated");
                return true;
            } catch (\PDOException | \Exception $exception) {
                if ($fromCMS) {
                    DB::rollBack();
                } else {
                    Manager::rollBack();
                }
                echo $oracle->SEGMENT1 . " " . $exception->getMessage(), PHP_EOL;
                (new LogsyncoracleModel)->setLogSync("Master Item / Barang : " . $oracle->INVENTORY_ITEM_ID . " - " . $oracle->SEGMENT1, Carbon::now()->toDateTimeString(), $exception->getMessage(), "failed");
                return false;
            }
        } else {
            if ($fromCMS) {
                DB::beginTransaction();
            } else {
                Manager::beginTransaction();
            }
            try {
                $model = new self();
                $model->mapperOracle($oracle);
                $model->save();
                if ($fromCMS) {
                    DB::commit();
                } else {
                    Manager::commit();
                }
                echo $model->namaItem . " " . $this->getTable() . "inserted ", PHP_EOL;
                (new LogsyncoracleModel)->setLogSync("Master Item / Barang : " . $oracle->INVENTORY_ITEM_ID . " - " . $oracle->SEGMENT1, Carbon::now()->toDateTimeString(), "", "inserted");
                return true;
            } catch (\Exception $exception) {
                if ($fromCMS) {
                    DB::rollBack();
                } else {
                    Manager::rollBack();
                }
                // FUNCTION TO INSERT INTO SYNCERROR TABLE IN CASE THE PROCESS ABOVE HAS SOME ERROR
                $params = json_encode([
                    "INVENTORY_ITEM_ID" => $oracle->INVENTORY_ITEM_ID,
                    "ORGANIZATION_ID" => $oracle->ORGANIZATION_ID
                ]);
                $data = json_encode($oracle);
                (new SyncerrorModel)->saveError("pelni_scm_items_v", $params, $data, "HO");

                echo $oracle->SEGMENT1 . " " . $exception->getMessage(), PHP_EOL;
                (new LogsyncoracleModel)->setLogSync("Master Item / Barang : " . $oracle->INVENTORY_ITEM_ID . " - " . $oracle->SEGMENT1, Carbon::now()->toDateTimeString(), $exception->getMessage(), "failed");
                return false;
            }
        }
    }

    public static function getItem($fromCMS = false)
    {
        $url = $GLOBALS["env"]["HEAD_OFFICE_URL"] . "/api/sync_item";
        $syncTable = (new \App\Http\Models\SyncUtilities\SyncTableHandlerModel())->getQuery()->where("sync_table.id", "=", 1)->first();
        $fetch = true;
        $page = 1;
        $no = 1;
        (new LogsynckapalModel)->setLogSync("Item HO to Kapal", Carbon::now()->toDateTimeString(), "", "start");
        do {
            if ($syncTable) {
                $lastUpdate = Carbon::parse($syncTable->last_sync)->toAtomString();
                $url = $url . "?date_updated=" . $lastUpdate . "&kapalId=" . $GLOBALS["env"]["KAPAL_ID"] . "&page=" . $page;
                $syncHandler = new \App\Http\Handler\CurlHandler();
                try {
                    $response = $syncHandler->setUrl($url)->send();
                    $res = json_decode($response, false);

                    if (!empty($res->data)) {
                        foreach ($res->data as $item) {
                            echo "data " . $no;
                            \App\Http\Models\ItemModel::storeFromHO($item, $fromCMS);
                            $lastUpdate = $item->date_updated;
                            $no = $no + 1;
                        }
                        $sync = \App\Http\Models\SyncUtilities\SyncTableHandlerModel::find($syncTable->id);
                        $sync->last_sync = $lastUpdate;
                        $sync->update();
                    } else {
                        $fetch = false;
                    }
                } catch (\Exception $e) {
                    echo $e->getMessage();
                    (new LogsynckapalModel)->setLogSync("Item HO to Kapal", Carbon::now()->toDateTimeString(), $e->getMessage(), "failed");
                }
                $page = $page + 1;
            }
        } while ($fetch);

        (new LogsynckapalModel)->setLogSync("Item HO to Kapal", Carbon::now()->toDateTimeString(), "", "success");
    }

    public static function storeFromHO($data, $fromCMS = false)
    {
        $image = null;

        if (!empty($data->image)) {
            $fileSyncHandler = new FileSyncHelper();
            $fileSyncHandler->setUrl($GLOBALS["env"]["HEAD_OFFICE_URL"] . "/" . $data->image);
            $fileSyncHandler->productFile()->setNameFile(md5($data->image) . ".jpg");
            $fileSyncHandler->store();
            $image = $fileSyncHandler->getFile();
        }

        //       $model = (new self())->getQuery()->where("item.id", "=", $data->id)->first();
        $itemExist = (new self())->getQuery()->where("item.id", "=", $data->id)->first();
        if ($itemExist) {
            try {
                $updateItem = self::find($itemExist->row_id);
                if ($updateItem) {
                    //$updateItem->id = $data->id;
                    $updateItem->namaItem = $data->namaItem;
                    $updateItem->deskripsi = utf8_encode($data->deskripsi);
                    $updateItem->category = $data->category;
                    $updateItem->UOM = $data->UOM;
                    $updateItem->date_updated = $data->date_updated;
                    $updateItem->expense_account = $data->expense_account;
                    $updateItem->destination_type_code = $data->destination_type_code;
                    $updateItem->item_price = $data->item_price;
                    $updateItem->kapalId = $data->kapalId;
                    $updateItem->expense_account_id = $data->expense_account_id;
                    $updateItem->image = $image;
                    $updateItem->part_number = utf8_encode($data->part_number);
                    $updateItem->instalasi = $data->instalasi;
                    $updateItem->jenis_instalasi = $data->jenis_instalasi;
                    $updateItem->enabled_flex = $data->enabled_flex;
                    $updateItem->item_groups = $data->item_groups;
                    $updateItem->type_id = $data->type_id;
                    $updateItem->item_subgroups = $data->item_subgroups;
                    $updateItem->item_subsubgroups = $data->item_subsubgroups;
                    $updateItem->meal_class = $data->meal_class;
                    $updateItem->meal_type = $data->meal_type;
                    $updateItem->stockable = $data->stockable;
                    $updateItem->update();
                    echo $data->namaItem . " updated", PHP_EOL;
                    (new LogsynckapalModel)->setLogSync("Sync Item HO to Kapal - " . $data->id . " - " . $data->namaItem, Carbon::now()->toDateTimeString(), "", "updated");
                    return true;
                }
                return false;
            } catch (\Exception $exception) {
                (new LogsynckapalModel)->setLogSync("Sync Item HO to Kapal - " . $data->id . " - " . $data->namaItem, Carbon::now()->toDateTimeString(), "Failed to Update Item <br /> " . $exception->getMessage(), "failed");
                return false;
            }
        } else {
            if ($fromCMS) {
                DB::beginTransaction();
            } else {
                Manager::beginTransaction();
            }
            try {
                $model = new self();
                $model->id = $data->id;
                $model->namaItem = $data->namaItem;
                $model->deskripsi = utf8_encode($data->deskripsi);
                $model->category = $data->category;
                $model->UOM = $data->UOM;
                $model->date_updated = $data->date_updated;
                $model->expense_account = $data->expense_account;
                $model->destination_type_code = $data->destination_type_code;
                $model->item_price = $data->item_price;
                $model->kapalId = $data->kapalId;
                $model->expense_account_id = $data->expense_account_id;
                $model->image = $image;
                $model->part_number = utf8_encode($data->part_number);
                $model->instalasi = $data->instalasi;
                $model->jenis_instalasi = $data->jenis_instalasi;
                $model->enabled_flex = $data->enabled_flex;
                $model->item_groups = $data->item_groups;
                $model->type_id = $data->type_id;
                $model->item_subgroups = $data->item_subgroups;
                $model->item_subsubgroups = $data->item_subsubgroups;
                $model->meal_class = $data->meal_class;
                $model->meal_type = $data->meal_type;
                $model->stockable = $data->stockable;
                $model->save([], $data->id, 0);

                if ($fromCMS) {
                    DB::commit();
                } else {
                    Manager::commit();
                }
                echo $data->namaItem . " created", PHP_EOL;
                (new LogsynckapalModel)->setLogSync("Sync Item HO to Kapal " . $data->id . " - " . $data->namaItem, Carbon::now()->toDateTimeString(), "", "inserted");
                return true;
            } catch (\Exception $exception) {
                if ($fromCMS) {
                    DB::rollBack();
                } else {
                    Manager::rollBack();
                }
                // FUNCTION TO INSERT INTO SYNCERROR TABLE IN CASE THE PROCESS ABOVE HAS SOME ERROR
                $params = json_encode([
                    "id" => $data->id,
                    "kapalId" => $data->kapalId
                ]);
                $dataError = json_encode($data);
                (new SyncerrorModel)->saveError("item", $params, $dataError, "KAPAL");
                (new LogsynckapalModel)->setLogSync("Sync Item HO to Kapal " . $data->id . " - " . $data->namaItem, Carbon::now()->toDateTimeString(), $exception->getMessage(), "failed");
                return false;
            }
        }
    }
}
